#!/usr/bin/python
# -* coding: iso-8859-1 -*-
"""
**********************************************************************
File Name:             Test_I2C_RS485.py
Dev:                   Daniele De Santis
Email:                 desantis@areasx.com
Web:                   http://www.areasx.com

Versione:              0.0
Data:                  19/02/15
Note Hardware:  
Note Software: 
**********************************************************************
"""

import time
import sys
import smbus
import RPi.GPIO as GPIO


def StringToBytes(val):
  retVal = []
  for c in val: retVal.append(ord(c))
  return retVal



#***************************************
#MAIM
#***************************************
print "Test I2C RS485"

GPIO.setmode(GPIO.BOARD)
bus = smbus.SMBus(1)

GPIO.setup(11, GPIO.IN)  #11  GPIO  17  IC interrupt 

bus.write_byte_data(0x04,0x03,0x00) #Disabilito il Watchdog
time.sleep(0.1)
print "----Setup RS485----"
#To enable RS485 you need to set bit 7 of register 0x16 to 1.
read_buf = bus.read_byte_data(0x04,0x16)
#Set 1 7 bit
read_buf |= 0x01 << 7
bus.write_byte_data(0x04,0x16,read_buf)
#enable  IC interrupt 
read_buf = bus.read_byte_data(0x04,0x19)
read_buf |= 0x01 << 6
bus.write_byte_data(0x04,0x19,read_buf)

#Setup boudrate a 19200bps
bus.write_byte_data(0x04,0x64,0x02)

#Lettura Baudrate
read_buf = bus.read_byte_data(0x04,0x64)
print "baudrate:  0 - 4800, 1 - 9600. 2 - 19200, 3 - 38400, 4 - 115200." 
print read_buf

#Scrivo sul bus RS485
print "TX -->PROVA RS485 EzMOTO!"
bus.write_i2c_block_data(0x04,0x85,StringToBytes("PROVA RS485 EzMOTO!"))
time.sleep(1)

#Lettura RS485
while(1):
  time.sleep(0.5)
  #if(GPIO.input(11)==0): #Wait until GPIO17 turns to 0.
  read_buf = bus.read_byte_data(0x04,0x1B) #  Check bit 6 of register 0x1B. Must be equal to 1.
  if((read_buf>>6 & 0x01)==0x01): #il buffer contiene caratteri
    rx_byte = 1;
    rx_str  = "";
    while(rx_byte):
      rx_byte = bus.read_byte_data(0x04,0x65)
      if(rx_byte):
        rx_buff =bus.read_i2c_block_data(0x04, 0x84, int(rx_byte))
        print rx_buff
        for rx_ch in rx_buff:
          if(int(rx_ch)>128):
            rx_ch=int(rx_ch)-128
          rx_str += chr(rx_ch)
      else:
        break
    
    print "RX STRING -> ",
    print rx_str

GPIO.cleanup()

  